class Matrix3D {
   // $FF: renamed from: xx float
   float field_0 = 1.0F;
   // $FF: renamed from: xy float
   float field_1;
   // $FF: renamed from: xz float
   float field_2;
   // $FF: renamed from: xo float
   float field_3;
   // $FF: renamed from: yx float
   float field_4;
   // $FF: renamed from: yy float
   float field_5 = 1.0F;
   // $FF: renamed from: yz float
   float field_6;
   // $FF: renamed from: yo float
   float field_7;
   // $FF: renamed from: zx float
   float field_8;
   // $FF: renamed from: zy float
   float field_9;
   // $FF: renamed from: zz float
   float field_10 = 1.0F;
   // $FF: renamed from: zo float
   float field_11;
   // $FF: renamed from: pi double
   static final double field_12 = 3.14159265;

   void scale(float var1) {
      this.field_0 *= var1;
      this.field_1 *= var1;
      this.field_2 *= var1;
      this.field_3 *= var1;
      this.field_4 *= var1;
      this.field_5 *= var1;
      this.field_6 *= var1;
      this.field_7 *= var1;
      this.field_8 *= var1;
      this.field_9 *= var1;
      this.field_10 *= var1;
      this.field_11 *= var1;
   }

   void scale(float var1, float var2, float var3) {
      this.field_0 *= var1;
      this.field_1 *= var1;
      this.field_2 *= var1;
      this.field_3 *= var1;
      this.field_4 *= var2;
      this.field_5 *= var2;
      this.field_6 *= var2;
      this.field_7 *= var2;
      this.field_8 *= var3;
      this.field_9 *= var3;
      this.field_10 *= var3;
      this.field_11 *= var3;
   }

   void translate(float var1, float var2, float var3) {
      this.field_3 += var1;
      this.field_7 += var2;
      this.field_11 += var3;
   }

   void yrot(double var1) {
      var1 *= 0.017453292500000002;
      double var3 = Math.cos(var1);
      double var5 = Math.sin(var1);
      float var7 = (float)((double)this.field_0 * var3 + (double)this.field_8 * var5);
      float var8 = (float)((double)this.field_1 * var3 + (double)this.field_9 * var5);
      float var9 = (float)((double)this.field_2 * var3 + (double)this.field_10 * var5);
      float var10 = (float)((double)this.field_3 * var3 + (double)this.field_11 * var5);
      float var11 = (float)((double)this.field_8 * var3 - (double)this.field_0 * var5);
      float var12 = (float)((double)this.field_9 * var3 - (double)this.field_1 * var5);
      float var13 = (float)((double)this.field_10 * var3 - (double)this.field_2 * var5);
      float var14 = (float)((double)this.field_11 * var3 - (double)this.field_3 * var5);
      this.field_3 = var10;
      this.field_0 = var7;
      this.field_1 = var8;
      this.field_2 = var9;
      this.field_11 = var14;
      this.field_8 = var11;
      this.field_9 = var12;
      this.field_10 = var13;
   }

   void xrot(double var1) {
      var1 *= 0.017453292500000002;
      double var3 = Math.cos(var1);
      double var5 = Math.sin(var1);
      float var7 = (float)((double)this.field_4 * var3 + (double)this.field_8 * var5);
      float var8 = (float)((double)this.field_5 * var3 + (double)this.field_9 * var5);
      float var9 = (float)((double)this.field_6 * var3 + (double)this.field_10 * var5);
      float var10 = (float)((double)this.field_7 * var3 + (double)this.field_11 * var5);
      float var11 = (float)((double)this.field_8 * var3 - (double)this.field_4 * var5);
      float var12 = (float)((double)this.field_9 * var3 - (double)this.field_5 * var5);
      float var13 = (float)((double)this.field_10 * var3 - (double)this.field_6 * var5);
      float var14 = (float)((double)this.field_11 * var3 - (double)this.field_7 * var5);
      this.field_7 = var10;
      this.field_4 = var7;
      this.field_5 = var8;
      this.field_6 = var9;
      this.field_11 = var14;
      this.field_8 = var11;
      this.field_9 = var12;
      this.field_10 = var13;
   }

   void zrot(double var1) {
      var1 *= 0.017453292500000002;
      double var3 = Math.cos(var1);
      double var5 = Math.sin(var1);
      float var7 = (float)((double)this.field_4 * var3 + (double)this.field_0 * var5);
      float var8 = (float)((double)this.field_5 * var3 + (double)this.field_1 * var5);
      float var9 = (float)((double)this.field_6 * var3 + (double)this.field_2 * var5);
      float var10 = (float)((double)this.field_7 * var3 + (double)this.field_3 * var5);
      float var11 = (float)((double)this.field_0 * var3 - (double)this.field_4 * var5);
      float var12 = (float)((double)this.field_1 * var3 - (double)this.field_5 * var5);
      float var13 = (float)((double)this.field_2 * var3 - (double)this.field_6 * var5);
      float var14 = (float)((double)this.field_3 * var3 - (double)this.field_7 * var5);
      this.field_7 = var10;
      this.field_4 = var7;
      this.field_5 = var8;
      this.field_6 = var9;
      this.field_3 = var14;
      this.field_0 = var11;
      this.field_1 = var12;
      this.field_2 = var13;
   }

   void mult(Matrix3D var1) {
      float var2 = this.field_0 * var1.field_0 + this.field_4 * var1.field_1 + this.field_8 * var1.field_2;
      float var3 = this.field_1 * var1.field_0 + this.field_5 * var1.field_1 + this.field_9 * var1.field_2;
      float var4 = this.field_2 * var1.field_0 + this.field_6 * var1.field_1 + this.field_10 * var1.field_2;
      float var5 = this.field_3 * var1.field_0 + this.field_7 * var1.field_1 + this.field_11 * var1.field_2 + var1.field_3;
      float var6 = this.field_0 * var1.field_4 + this.field_4 * var1.field_5 + this.field_8 * var1.field_6;
      float var7 = this.field_1 * var1.field_4 + this.field_5 * var1.field_5 + this.field_9 * var1.field_6;
      float var8 = this.field_2 * var1.field_4 + this.field_6 * var1.field_5 + this.field_10 * var1.field_6;
      float var9 = this.field_3 * var1.field_4 + this.field_7 * var1.field_5 + this.field_11 * var1.field_6 + var1.field_7;
      float var10 = this.field_0 * var1.field_8 + this.field_4 * var1.field_9 + this.field_8 * var1.field_10;
      float var11 = this.field_1 * var1.field_8 + this.field_5 * var1.field_9 + this.field_9 * var1.field_10;
      float var12 = this.field_2 * var1.field_8 + this.field_6 * var1.field_9 + this.field_10 * var1.field_10;
      float var13 = this.field_3 * var1.field_8 + this.field_7 * var1.field_9 + this.field_11 * var1.field_10 + var1.field_11;
      this.field_0 = var2;
      this.field_1 = var3;
      this.field_2 = var4;
      this.field_3 = var5;
      this.field_4 = var6;
      this.field_5 = var7;
      this.field_6 = var8;
      this.field_7 = var9;
      this.field_8 = var10;
      this.field_9 = var11;
      this.field_10 = var12;
      this.field_11 = var13;
   }

   void unit() {
      this.field_3 = 0.0F;
      this.field_0 = 1.0F;
      this.field_1 = 0.0F;
      this.field_2 = 0.0F;
      this.field_7 = 0.0F;
      this.field_4 = 0.0F;
      this.field_5 = 1.0F;
      this.field_6 = 0.0F;
      this.field_11 = 0.0F;
      this.field_8 = 0.0F;
      this.field_9 = 0.0F;
      this.field_10 = 1.0F;
   }

   void transform(float[] var1, int[] var2, int var3) {
      float var4 = this.field_0;
      float var5 = this.field_1;
      float var6 = this.field_2;
      float var7 = this.field_3;
      float var8 = this.field_4;
      float var9 = this.field_5;
      float var10 = this.field_6;
      float var11 = this.field_7;
      float var12 = this.field_8;
      float var13 = this.field_9;
      float var14 = this.field_10;
      float var15 = this.field_11;
      int var16 = var3 * 3;

      while(true) {
         var16 -= 3;
         if (var16 < 0) {
            return;
         }

         float var17 = var1[var16];
         float var18 = var1[var16 + 1];
         float var19 = var1[var16 + 2];
         var2[var16] = (int)(var17 * var4 + var18 * var5 + var19 * var6 + var7);
         var2[var16 + 1] = (int)(var17 * var8 + var18 * var9 + var19 * var10 + var11);
         var2[var16 + 2] = (int)(var17 * var12 + var18 * var13 + var19 * var14 + var15);
      }
   }

   public String toString() {
      return "[" + this.field_3 + "," + this.field_0 + "," + this.field_1 + "," + this.field_2 + ";" + this.field_7 + "," + this.field_4 + "," + this.field_5 + "," + this.field_6 + ";" + this.field_11 + "," + this.field_8 + "," + this.field_9 + "," + this.field_10 + "]";
   }
}
